/*
 * timing.c
 *
 * Created: 18.12.2011 17:16:37
 *  Author: Chris
 */ 

#include "timing.h"
#include <avr/pgmspace.h>
#include <avr/interrupt.h>


#define TIMINGDATALEN 2
volatile t_timingdata timingdata[2];

uint8_t pat1a[] = {45/5, 15/5, 25/5, 15/5, 25/5, 15/5, 145/5, 190/5};
uint8_t pat2a[] = {25/5, 15/5, 145/5, 190/5, 45/5, 15/5, 25/5, 15/5};
	
uint8_t pat1b[] = {2,7,2,17,2,7,2,70};
uint8_t pat2b[] = {2,7,2,70,2,7,2,17};

void timing_init() {
	timingdata[0].pat = pat1a;
	timingdata[0].patlen = 8;
	timingdata[0].pos_a = 0;
	timingdata[0].pos_t = 0;
	timingdata[0].port = &PORTB;
	timingdata[0].pin = PB2;

	timingdata[1].pat = pat1b;
	timingdata[1].patlen = 8;
	timingdata[1].pos_a = 0;
	timingdata[1].pos_t = 0;
	timingdata[1].port = &PORTB;
	timingdata[1].pin = PB0;

}

uint8_t timing_pattern = 0;

void timing_setpattern(uint8_t pattern) {
	timing_pattern = pattern;
	if(timing_pattern == 1) {
		timingdata[0].pat = pat1a;
		timingdata[1].pat = pat2a;
	} else {
		timingdata[0].pat = pat1b;
		timingdata[1].pat = pat2b;
	}
}

void timing_tick() {
	if(timing_pattern == 0) {
		PORTB &= ~((1<<PB0) | (1<<PB2));
		for(uint8_t i = 0; i < TIMINGDATALEN; i++) { timingdata[i].pos_a = 0; }
		
		return;
	}
	for(uint8_t i = 0; i < TIMINGDATALEN; i++) {
		if(timingdata[i].pos_t > 0) {
			timingdata[i].pos_t--;
		}
		if(timingdata[i].pos_t == 0) {
			timingdata[i].pos_a++;

			if(timingdata[i].pos_a == timingdata[i].patlen) { timingdata[i].pos_a = 0; }
			timingdata[i].pos_t = timingdata[i].pat[timingdata[i].pos_a];

			if((timingdata[i].pos_a & 1) == 0) {
				*timingdata[i].port |= (1<<timingdata[i].pin);
			} else {
				*timingdata[i].port &= ~(1<<timingdata[i].pin);
			}
		}
	}
}